import { _ as _objectWithoutPropertiesLoose, P as PropTypes } from './index.esm2.js';
import 'core-js/modules/es.regexp.to-string.js';
import React__default from 'react';
import RichTextEditor from 'react-rte';
import { jsxs, jsx } from 'react/jsx-runtime';
import '@qubejs/core';
import 'core-js/modules/es.object.assign.js';
import 'core-js/modules/es.promise.js';
import 'core-js/modules/es.regexp.exec.js';
import 'core-js/modules/es.string.search.js';
import 'core-js/modules/es.regexp.constructor.js';
import 'core-js/modules/es.string.match.js';
import 'core-js/modules/es.string.replace.js';
import 'tslib';
import 'core-js/modules/es.string.trim.js';
import 'lodash/filter';
import 'core-js/modules/es.array.sort.js';
import 'moment-timezone';
import 'core-js/modules/es.array.iterator.js';
import 'core-js/modules/es.promise.finally.js';
import 'core-js/modules/es.string.starts-with.js';
import 'core-js/modules/web.dom-collections.iterator.js';
import '@reduxjs/toolkit';
import 'core-js/modules/es.array.includes.js';
import 'core-js/modules/es.string.includes.js';
import 'core-js/modules/es.array.reduce.js';
import 'lodash/uniq';
import 'lodash/groupBy';
import '@emotion/react';
import '@mui/material/Button';
import '@mui/material/IconButton';
import '@mui/material/Typography';
import '@mui/material/Dialog';
import '@mui/material/DialogTitle';
import '@mui/material/DialogActions';
import '@mui/material/DialogContent';
import '@mui/material/Slide';
import '@mui/material/LinearProgress';
import '@mui/material/CircularProgress';
import '@mui/icons-material/SelectAll';
import '@mui/lab/Alert';
import '@mui/lab/AlertTitle';
import '@mui/material/Autocomplete';
import '@mui/material/Chip';
import '@mui/material/Box';
import '@mui/material';
import '@mui/material/TextField';
import '@mui/material/BottomNavigation';
import '@mui/material/BottomNavigationAction';
import '@mui/material/Breadcrumbs';
import '@mui/icons-material/NavigateNext';
import '@mui/material/ButtonGroup';
import '@mui/material/Tooltip';
import 'core-js/modules/es.symbol.description.js';
import '@mui/material/FormLabel';
import '@mui/material/FormControl';
import '@mui/material/FormControlLabel';
import '@mui/material/Checkbox';
import '@mui/material/FormGroup';
import '@mui/material/FormHelperText';
import 'react-html-parser';
import '@mui/material/Menu';
import '@mui/material/MenuItem';
import '@mui/material/ListItemIcon';
import '@mui/material/Divider';
import '@mui/material/List';
import '@mui/material/ListItem';
import '@mui/material/ListItemText';
import '@mui/x-date-pickers/DatePicker';
import '@mui/x-date-pickers/AdapterDateFns';
import '@mui/x-date-pickers/LocalizationProvider';
import '@mui/x-date-pickers/TimePicker';
import '@mui/x-date-pickers/DateTimePicker';
import '@mui/x-date-pickers/DesktopDatePicker';
import '@mui/x-date-pickers/MobileDatePicker';
import '@mui/material/Snackbar';
import '@mui/styles/withStyles';
import '@mui/icons-material/AttachFile';
import '@mui/icons-material/CloudUpload';
import '@mui/material/Fab';
import '@mui/material/Grid';
import '@mui/icons-material/Delete';
import '@mui/material/SnackbarContent';
import '@mui/styles';
import '@mui/icons-material/CheckCircle';
import '@mui/icons-material/Close';
import '@mui/icons-material/Error';
import '@mui/icons-material/Info';
import '@mui/icons-material/Warning';
import '@mui/material/Popover';
import 'material-ui-popup-state';
import 'immutability-helper';
import '@mui/material/ListItemButton';
import '@mui/material/Collapse';
import '@mui/material/Avatar';
import '@mui/material/Select';
import '@mui/material/OutlinedInput';
import '@mui/material/Input';
import '@mui/material/InputLabel';
import '@mui/material/Pagination';
import '@mui/material/AppBar';
import '@mui/material/Toolbar';
import '@mui/material/Badge';
import '@mui/material/Drawer';
import '@mui/icons-material/ExpandLess';
import '@mui/icons-material/ExpandMore';
import '@mui/material/Tabs';
import '@mui/material/Tab';
import '@mui/material/Radio';
import '@mui/material/RadioGroup';
import 'react-google-recaptcha';
import '@mui/material/ListSubheader';
import '@mui/material/Skeleton';
import '@mui/material/Slider';
import '@mui/lab/SpeedDial';
import '@mui/lab/SpeedDialIcon';
import '@mui/lab/SpeedDialAction';
import '@mui/material/Switch';
import 'react-redux';
import 'react-router-dom';
import 'lodash/sortBy';
import '@mui/lab/TreeView';
import '@mui/icons-material/ChevronRight';
import '@mui/lab/TreeItem';

const _excluded = ["label", "className", "formatter", "value", "error", "errorMessage"];
function getText(html) {
  var divContainer = document.createElement('div');
  divContainer.innerHTML = html;
  return divContainer.textContent || divContainer.innerText || '';
}
class BasicRTE extends React__default.Component {
  constructor() {
    super();
    this.state = {
      value: RichTextEditor.createEmptyValue(),
      focused: false,
      hasChanged: false
    };
    this.handleFocus = this.handleFocus.bind(this);
    this.handleBlur = this.handleBlur.bind(this);
    this.handleOnChange = this.handleOnChange.bind(this);
  }
  handleOnChange(value) {
    const html = value.toString('html');
    const hasText = getText(html);
    this.setState({
      value: value,
      hasChanged: true
    });
    const {
      onChange
    } = this.props;
    onChange && onChange({
      value: hasText && html
    });
  }
  componentDidMount() {
    if (this.props.value) {
      this.setState({
        value: RichTextEditor.createValueFromString(this.props.value, 'html')
      });
    }
  }
  componentDidUpdate(prevProps) {
    if (!this.state.focused && prevProps.value !== this.props.value) {
      this.setState({
        value: RichTextEditor.createValueFromString(this.props.value, 'html')
      });
    }
  }
  handleFocus() {
    this.setState({
      focused: true
    });
  }
  handleBlur() {
    this.props;
    this.setState({
      focused: false
    });
  }
  render() {
    const {
      focused
    } = this.state;
    const _this$props = this.props,
      {
        label,
        className = '',
        error,
        errorMessage
      } = _this$props;
      _objectWithoutPropertiesLoose(_this$props, _excluded);
    return /*#__PURE__*/jsxs("div", {
      className: `sq-basic-rte${focused ? ' sq-basic-rte--focused' : ''} ${className}`,
      children: [label && /*#__PURE__*/jsx("label", {
        htmlFor: "",
        children: label
      }), /*#__PURE__*/jsx(RichTextEditor, {
        onFocus: this.handleFocus,
        onBlur: this.handleBlur,
        onChange: this.handleOnChange,
        className: `sq-basic-rte__editor`,
        defaultValue: this.props.value,
        value: this.state.value
      }), !focused && error && /*#__PURE__*/jsx("div", {
        className: "sq-textarea-field--error",
        children: errorMessage
      })]
    });
  }
}
BasicRTE.propTypes = {
  errorMessage: PropTypes.string,
  className: PropTypes.string,
  value: PropTypes.any,
  formatter: PropTypes.object,
  onChange: PropTypes.func,
  onKeyPress: PropTypes.func,
  onBlur: PropTypes.func
};

export { BasicRTE as default };
