import 'core-js/modules/es.array.iterator.js';
import 'core-js/modules/es.object.assign.js';
import 'core-js/modules/web.dom-collections.iterator.js';
import { __rest, __awaiter } from 'tslib';
import { jsxs, jsx } from 'react/jsx-runtime';
import { useState } from 'react';
import { b as Progress, I as IconComp, d as Input, C as CustomButton, A as Alert, P as PropTypes } from './index.esm2.js';
import Tooltip from '@mui/material/Tooltip';
import { E } from './react-drag-drop-files.esm.esm.js';
import '@qubejs/core';
import 'core-js/modules/es.promise.js';
import 'core-js/modules/es.regexp.to-string.js';
import 'core-js/modules/es.regexp.exec.js';
import 'core-js/modules/es.string.search.js';
import 'core-js/modules/es.regexp.constructor.js';
import 'core-js/modules/es.string.match.js';
import 'core-js/modules/es.string.replace.js';
import 'core-js/modules/es.string.trim.js';
import 'lodash/filter';
import 'core-js/modules/es.array.sort.js';
import 'moment-timezone';
import 'core-js/modules/es.promise.finally.js';
import 'core-js/modules/es.string.starts-with.js';
import '@reduxjs/toolkit';
import 'core-js/modules/es.array.includes.js';
import 'core-js/modules/es.string.includes.js';
import 'core-js/modules/es.array.reduce.js';
import 'lodash/uniq';
import 'lodash/groupBy';
import '@emotion/react';
import '@mui/material/Button';
import '@mui/material/IconButton';
import '@mui/material/Typography';
import '@mui/material/Dialog';
import '@mui/material/DialogTitle';
import '@mui/material/DialogActions';
import '@mui/material/DialogContent';
import '@mui/material/Slide';
import '@mui/material/LinearProgress';
import '@mui/material/CircularProgress';
import '@mui/icons-material/SelectAll';
import '@mui/lab/Alert';
import '@mui/lab/AlertTitle';
import '@mui/material/Autocomplete';
import '@mui/material/Chip';
import '@mui/material/Box';
import '@mui/material';
import '@mui/material/TextField';
import '@mui/material/BottomNavigation';
import '@mui/material/BottomNavigationAction';
import '@mui/material/Breadcrumbs';
import '@mui/icons-material/NavigateNext';
import '@mui/material/ButtonGroup';
import 'core-js/modules/es.symbol.description.js';
import '@mui/material/FormLabel';
import '@mui/material/FormControl';
import '@mui/material/FormControlLabel';
import '@mui/material/Checkbox';
import '@mui/material/FormGroup';
import '@mui/material/FormHelperText';
import 'react-html-parser';
import '@mui/material/Menu';
import '@mui/material/MenuItem';
import '@mui/material/ListItemIcon';
import '@mui/material/Divider';
import '@mui/material/List';
import '@mui/material/ListItem';
import '@mui/material/ListItemText';
import '@mui/x-date-pickers/DatePicker';
import '@mui/x-date-pickers/AdapterDateFns';
import '@mui/x-date-pickers/LocalizationProvider';
import '@mui/x-date-pickers/TimePicker';
import '@mui/x-date-pickers/DateTimePicker';
import '@mui/x-date-pickers/DesktopDatePicker';
import '@mui/x-date-pickers/MobileDatePicker';
import '@mui/material/Snackbar';
import '@mui/styles/withStyles';
import '@mui/icons-material/AttachFile';
import '@mui/icons-material/CloudUpload';
import '@mui/material/Fab';
import '@mui/material/Grid';
import '@mui/icons-material/Delete';
import '@mui/material/SnackbarContent';
import '@mui/styles';
import '@mui/icons-material/CheckCircle';
import '@mui/icons-material/Close';
import '@mui/icons-material/Error';
import '@mui/icons-material/Info';
import '@mui/icons-material/Warning';
import '@mui/material/Popover';
import 'material-ui-popup-state';
import 'immutability-helper';
import '@mui/material/ListItemButton';
import '@mui/material/Collapse';
import '@mui/material/Avatar';
import '@mui/material/Select';
import '@mui/material/OutlinedInput';
import '@mui/material/Input';
import '@mui/material/InputLabel';
import '@mui/material/Pagination';
import '@mui/material/AppBar';
import '@mui/material/Toolbar';
import '@mui/material/Badge';
import '@mui/material/Drawer';
import '@mui/icons-material/ExpandLess';
import '@mui/icons-material/ExpandMore';
import '@mui/material/Tabs';
import '@mui/material/Tab';
import '@mui/material/Radio';
import '@mui/material/RadioGroup';
import 'react-google-recaptcha';
import '@mui/material/ListSubheader';
import '@mui/material/Skeleton';
import '@mui/material/Slider';
import '@mui/lab/SpeedDial';
import '@mui/lab/SpeedDialIcon';
import '@mui/lab/SpeedDialAction';
import '@mui/material/Switch';
import 'react-redux';
import 'react-router-dom';
import 'lodash/sortBy';
import '@mui/lab/TreeView';
import '@mui/icons-material/ChevronRight';
import '@mui/lab/TreeItem';

const SQFileUploader = _a => {
  var {
      className = '',
      disabled,
      fileTypes = ['JPG', 'PNG', 'GIF', 'PDF', 'JPEG', 'DOC', 'DOCX', 'PPT', 'PPTX', 'RTF'],
      multiple = true,
      clearAll = false,
      onAction,
      errorMessage,
      label,
      uploadButtonText = 'Upload',
      clearButtonText = 'Clear',
      uploadOnChange = false,
      allowRename = true,
      onChange,
      uploadSuccessMessage,
      uploadFailedMessage,
      successMessageType = 'info',
      enableLoader = false,
      errorMessageType = 'warning',
      value
    } = _a,
    rest = __rest(_a, ["className", "disabled", "fileTypes", "multiple", "clearAll", "onAction", "errorMessage", "label", "uploadButtonText", "clearButtonText", "uploadOnChange", "allowRename", "onChange", "uploadSuccessMessage", "uploadFailedMessage", "successMessageType", "enableLoader", "errorMessageType", "value"]);
  const [file, setFile] = useState([]);
  const [fileNames, setFileNames] = useState([]);
  const [sucessCalled, setSuccessCalled] = useState(false);
  const [progress, setProgress] = useState(false);
  const [failedCalled, setFailedCalled] = useState(false);
  const handleChange = filenew => __awaiter(void 0, void 0, void 0, function* () {
    const takeOne = multiple ? filenew : [filenew];
    const listToBeAdded = [].filter.call(takeOne, i => file.filter(d => d.name === i.name).length === 0);
    if (listToBeAdded.length > 0) {
      const newFiles = [...(multiple ? file : []), ...listToBeAdded];
      yield setFile(newFiles);
      const newFileNames = [...fileNames, ...listToBeAdded.map(i => ({
        name: i.name
      }))];
      yield setFileNames(newFileNames);
      uploadOnChange && handleAction({
        files: newFiles
      });
    }
  });
  const handleDelete = filenew => {
    const idx = file.indexOf(filenew);
    file.splice(idx, 1);
    fileNames.splice(idx, 1);
    setFile([...file]);
    setFileNames([...fileNames]);
  };
  const success = data => {
    onChange && onChange({
      value: data,
      checkForAction: false
    });
    setSuccessCalled(true);
    setProgress(false);
    setFailedCalled(false);
  };
  const failed = () => {
    onChange && onChange({
      value: null,
      checkForAction: false
    });
    setSuccessCalled(false);
    setFailedCalled(true);
    setProgress(false);
  };
  const handleFileChange = (data, file, idx) => {
    const newFileNames = [...fileNames];
    newFileNames[idx] = {
      name: data.value
    };
    setFileNames(newFileNames);
  };
  const handleAction = obj => {
    setProgress(true);
    onAction && onAction({}, Object.assign(Object.assign({}, rest), {
      success,
      failed,
      data: {
        files: obj && obj.files || file,
        fileNames
      }
    }));
    setFile([]);
  };
  const handleClear = () => {
    setFile([]);
  };
  return jsxs("div", {
    className: `sq-file-uploader ${className}`,
    children: [label && jsx("label", {
      className: "sq-file-uploader__label",
      children: label
    }), jsx(Tooltip, {
      title: fileTypes.join(', ').toLowerCase(),
      children: jsx("span", {
        children: jsx(E, {
          disabled: disabled,
          multiple: multiple,
          fileOrFiles: file.length ? null : file,
          className: "sq-file-uploader__file",
          handleChange: handleChange,
          name: "file",
          types: fileTypes
        })
      })
    }), enableLoader && progress && jsx(Progress, {
      className: "tp-progress--active",
      style: "default"
    }), file && jsx("div", {
      className: "sq-file-uploader__list",
      children: file.map((file, idx) => {
        var _a;
        return jsxs("div", {
          title: file.name,
          className: "sq-file-uploader__file-item",
          children: [jsx("div", {
            className: "sq-file-uploader__file-icon",
            children: jsx(IconComp, {
              name: "file",
              size: "small"
            })
          }), jsxs("div", {
            className: "sq-file-uploader__file-name pt-2",
            children: [allowRename && jsx(Input, {
              helperText: file.name,
              label: "Name",
              type: "text",
              value: (_a = fileNames[idx]) === null || _a === void 0 ? void 0 : _a.name,
              onKeyPress: data => handleFileChange(data, file, idx)
            }), !allowRename && file.name]
          }), jsx("div", {
            className: "sq-file-uploader__file-delete",
            onClick: () => handleDelete(file),
            children: jsx(IconComp, {
              name: "close",
              size: "small",
              variant: "error"
            })
          })]
        }, file.name);
      })
    }), errorMessage && jsx("div", {
      className: "sq-error",
      children: errorMessage
    }), !uploadOnChange && jsx(CustomButton, {
      disabled: file.length === 0,
      variant: "outlined",
      onClick: handleAction,
      buttonText: uploadButtonText
    }), clearAll && jsx(CustomButton, {
      disabled: file.length === 0,
      variant: "outlined",
      onClick: handleClear,
      buttonText: clearButtonText
    }), uploadSuccessMessage && !progress && sucessCalled && jsx(Alert, {
      type: successMessageType,
      message: uploadSuccessMessage
    }), uploadFailedMessage && !progress && failedCalled && jsx(Alert, {
      type: errorMessageType,
      message: uploadFailedMessage
    })]
  });
};
SQFileUploader.propTypes = {
  className: PropTypes.string,
  uploadButtonText: PropTypes.string,
  clearButtonText: PropTypes.string,
  errorMessage: PropTypes.string,
  onChange: PropTypes.func,
  actionOnSelect: PropTypes.bool,
  clearAll: PropTypes.bool
};

export { SQFileUploader as default };
