import 'core-js/modules/es.object.assign.js';
import { __rest } from 'tslib';
import { jsx } from 'react/jsx-runtime';
import { Component } from 'react';
import { P as PropTypes, H as HeroContent, e as ImageOnDevice, f as ImageWithSlide, j as ImageWithSlideList } from './index.esm2.js';
import gsap from 'gsap';
import { ScrollTrigger } from 'gsap/ScrollTrigger';
import '@qubejs/core';
import 'core-js/modules/es.promise.js';
import 'core-js/modules/es.regexp.to-string.js';
import 'core-js/modules/es.regexp.exec.js';
import 'core-js/modules/es.string.search.js';
import 'core-js/modules/es.regexp.constructor.js';
import 'core-js/modules/es.string.match.js';
import 'core-js/modules/es.string.replace.js';
import 'core-js/modules/es.string.trim.js';
import 'lodash/filter';
import 'core-js/modules/es.array.sort.js';
import 'moment-timezone';
import 'core-js/modules/es.array.iterator.js';
import 'core-js/modules/es.promise.finally.js';
import 'core-js/modules/es.string.starts-with.js';
import 'core-js/modules/web.dom-collections.iterator.js';
import '@reduxjs/toolkit';
import 'core-js/modules/es.array.includes.js';
import 'core-js/modules/es.string.includes.js';
import 'core-js/modules/es.array.reduce.js';
import 'lodash/uniq';
import 'lodash/groupBy';
import '@emotion/react';
import '@mui/material/Button';
import '@mui/material/IconButton';
import '@mui/material/Typography';
import '@mui/material/Dialog';
import '@mui/material/DialogTitle';
import '@mui/material/DialogActions';
import '@mui/material/DialogContent';
import '@mui/material/Slide';
import '@mui/material/LinearProgress';
import '@mui/material/CircularProgress';
import '@mui/icons-material/SelectAll';
import '@mui/lab/Alert';
import '@mui/lab/AlertTitle';
import '@mui/material/Autocomplete';
import '@mui/material/Chip';
import '@mui/material/Box';
import '@mui/material';
import '@mui/material/TextField';
import '@mui/material/BottomNavigation';
import '@mui/material/BottomNavigationAction';
import '@mui/material/Breadcrumbs';
import '@mui/icons-material/NavigateNext';
import '@mui/material/ButtonGroup';
import '@mui/material/Tooltip';
import 'core-js/modules/es.symbol.description.js';
import '@mui/material/FormLabel';
import '@mui/material/FormControl';
import '@mui/material/FormControlLabel';
import '@mui/material/Checkbox';
import '@mui/material/FormGroup';
import '@mui/material/FormHelperText';
import 'react-html-parser';
import '@mui/material/Menu';
import '@mui/material/MenuItem';
import '@mui/material/ListItemIcon';
import '@mui/material/Divider';
import '@mui/material/List';
import '@mui/material/ListItem';
import '@mui/material/ListItemText';
import '@mui/x-date-pickers/DatePicker';
import '@mui/x-date-pickers/AdapterDateFns';
import '@mui/x-date-pickers/LocalizationProvider';
import '@mui/x-date-pickers/TimePicker';
import '@mui/x-date-pickers/DateTimePicker';
import '@mui/x-date-pickers/DesktopDatePicker';
import '@mui/x-date-pickers/MobileDatePicker';
import '@mui/material/Snackbar';
import '@mui/styles/withStyles';
import '@mui/icons-material/AttachFile';
import '@mui/icons-material/CloudUpload';
import '@mui/material/Fab';
import '@mui/material/Grid';
import '@mui/icons-material/Delete';
import '@mui/material/SnackbarContent';
import '@mui/styles';
import '@mui/icons-material/CheckCircle';
import '@mui/icons-material/Close';
import '@mui/icons-material/Error';
import '@mui/icons-material/Info';
import '@mui/icons-material/Warning';
import '@mui/material/Popover';
import 'material-ui-popup-state';
import 'immutability-helper';
import '@mui/material/ListItemButton';
import '@mui/material/Collapse';
import '@mui/material/Avatar';
import '@mui/material/Select';
import '@mui/material/OutlinedInput';
import '@mui/material/Input';
import '@mui/material/InputLabel';
import '@mui/material/Pagination';
import '@mui/material/AppBar';
import '@mui/material/Toolbar';
import '@mui/material/Badge';
import '@mui/material/Drawer';
import '@mui/icons-material/ExpandLess';
import '@mui/icons-material/ExpandMore';
import '@mui/material/Tabs';
import '@mui/material/Tab';
import '@mui/material/Radio';
import '@mui/material/RadioGroup';
import 'react-google-recaptcha';
import '@mui/material/ListSubheader';
import '@mui/material/Skeleton';
import '@mui/material/Slider';
import '@mui/lab/SpeedDial';
import '@mui/lab/SpeedDialIcon';
import '@mui/lab/SpeedDialAction';
import '@mui/material/Switch';
import 'react-redux';
import 'react-router-dom';
import 'lodash/sortBy';
import '@mui/lab/TreeView';
import '@mui/icons-material/ChevronRight';
import '@mui/lab/TreeItem';

gsap.registerPlugin(ScrollTrigger);
const compMap = {
  HeroContent,
  ImageOnDevice,
  ImageWithSlide,
  ImageWithSlideList
};
const presetAnimation = {
  sliderWithScrub: {}
};
class MagicHeroContentDefault extends Component {
  constructor(props) {
    super(props);
    this.state = {};
  }
  getTarget(target) {
    const {
      name
    } = this.props;
    if (target && target.rule) {
      return CSSRulePlugin.getRule(target.rule);
    }
    return (name ? '.' + name + ' ' : '') + target;
  }
  applyTweens(tweens, timeline) {
    this.allTweens = [];
    tweens.forEach(tween => {
      const {
          target,
          start
        } = tween,
        restTween = __rest(tween, ["target", "start"]);
      if (restTween.from && restTween.to) {
        this.allTweens.push((timeline || gsap).fromTo(this.getTarget(target), restTween.from, restTween.to, start));
      } else if (restTween.from) {
        this.allTweens.push((timeline || gsap).from(this.getTarget(target), restTween.from, start));
      } else if (restTween.to) {
        this.allTweens.push((timeline || gsap).to(this.getTarget(target), restTween.to, start));
      }
    });
  }
  getTimeline() {
    let {
      timeline
    } = this.props;
    const {
      tweens,
      animation
    } = this.props;
    if (presetAnimation[animation]) {
      timeline = presetAnimation[animation];
    }
    return {
      tweens,
      timeline
    };
  }
  componentDidMount() {
    const {
      tweens,
      timeline
    } = this.getTimeline();
    const _a = JSON.parse(JSON.stringify(timeline || {})),
      {
        tweens: tlTweens = []
      } = _a,
      restTimeline = __rest(_a, ["tweens"]);
    if (timeline) {
      this.tlObj = gsap.timeline(restTimeline);
      this.trigger = restTimeline.trigger;
      tlTweens && this.applyTweens(tlTweens, this.tlObj);
    }
    tweens && this.applyTweens(tweens);
    setTimeout(() => {
      (restTimeline === null || restTimeline === void 0 ? void 0 : restTimeline.scrollTrigger) && ScrollTrigger.refresh();
    }, 500);
  }
  componentWillUnmount() {
    this.killAll();
  }
  killAll() {
    var _a, _b, _c;
    (_a = this.allTweens) === null || _a === void 0 ? void 0 : _a.forEach(tween => {
      tween && tween.kill(true);
    });
    ((_b = this.tlObj) === null || _b === void 0 ? void 0 : _b.scrollTrigger) && this.tlObj.scrollTrigger.kill(true);
    (_c = this.tlObj) === null || _c === void 0 ? void 0 : _c.pause(0).kill(true);
    this.tlObj = null;
  }
  render() {
    const _a = this.props,
      {
        name,
        content = {},
        className = ''
      } = _a,
      restProps = __rest(_a, ["name", "content", "className"]);
    const {
        component
      } = content,
      restContent = __rest(content, ["component"]);
    const CmpToRender = compMap[component] || compMap.HeroContent;
    return jsx("div", {
      className: `sq-magic-hero-content-pencil ${className} ${name}`,
      children: jsx(CmpToRender, Object.assign({}, restProps, restContent))
    });
  }
}
MagicHeroContentDefault.propTypes = {
  items: PropTypes.array
};

export { MagicHeroContentDefault as default };
